/**********************/
/* Free RAM Accessory */
/*   by Tom Hudson    */
/**********************/

/**********************/
/* EXTERNALS	      */
/**********************/

extern int gl_apid;
extern long m_alloc();

/**********************/
/* GLOBAL VARIABLES   */
/**********************/

int contrl[12];
int intin[128];
int ptsin[128];
int intout[128];
int ptsout[128];

char rs_strings[] = "[0][Available RAM: 0000000 bytes][  OK  ]";

int mgbuf[8];

int menu_id ;	/* our menu id */
int forever=0;
long freeram;

/**************************************************************/
/* Init accessory, store accessory title in system's menu bar */
/* then wait for a message using evnt_mesag().  When we get   */
/* an open (message type 40), we grab free memory via the     */
/* m_alloc(-1L) call, convert it into a string and do the     */
/* form_alert, which shows it to the user.  The user clicks   */
/* on OK, and the accessory goes to sleep until it's called   */
/* again by waiting for another evnt_mesag.                   */
/**************************************************************/

main()
{
appl_init();
menu_id=menu_register(gl_apid,"  Free RAM size");

while(forever==0)
 {
 evnt_mesag(mgbuf);
 if((mgbuf[0]==40) && (mgbuf[4]==menu_id))
  {
  freeram=m_alloc(-1L);
  longasc(freeram,&rs_strings[19]);
  form_alert(1,&rs_strings[0]);
  }
 }
}

/****************************************************************/
/* This routine converts a LONG variable into a string.  Custom */
/* written for this accessory, it works with numbers up to      */
/* 9,999,999.  Pass the long value and the string which is to   */
/* receive the ASCII value.                                     */
/****************************************************************/

longasc(value,string)
long value;
char *string;
{
long divfac,subfac;
char *index,digit;

index=string;
for(divfac=1000000L; divfac>0; ++index,divfac/=10L)
 {
 digit=value/divfac;
 value=value-digit*divfac;
 *index=digit+48;
 }
}
""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""